const jwt = require('express-jwt');
const { secret } = require('config.json');
const db = require('_helpers/db');

module.exports = gamerauthorize;
 
function gamerauthorize() {
    return [
        // authenticate JWT token and attach decoded token to request as req.parent
        jwt({ secret, algorithms: ['HS256'] }),

        // attach full gamer record to request object
        async (req, res, next) => {
            // get gamer with id from token 'sub' (subject) property

            const gamer = await db.Gamer.findByPk(req.user.sub);

            // check gamer still exists
            if (!gamer)
                return res.status(401).json({ message: 'Unauthorized' });

            // authorization successful
            req.gamer = gamer.get();
            next();
        }
    ];
}