const jwt = require('express-jwt');
const { secret } = require('config.json');
const db = require('_helpers/db');

module.exports = parentauthorize;
 
function parentauthorize() {
    return [
        // authenticate JWT token and attach decoded token to request as req.parent
        jwt({ secret, algorithms: ['HS256'] }),

        // attach full parent record to request object
        async (req, res, next) => {
            // get parent with id from token 'sub' (subject) property

            const parent = await db.Parent.findByPk(req.user.sub);

            // check parent still exists
            if (!parent)
                return res.status(401).json({ message: 'Unauthorized' });

            // authorization successful
            req.parent = parent.get();
            next();
        }
    ];
}